# Build

This file describes the build system of this software. The build system is so complex that it requires its own documentation. And this is it.

So, before you can build this software, you need to make sure that your system supports all [external dependencies](external.md). If you are sure that your system supports all external dependencies, you can proceed to the next step.

The build system is based on [cmake](https://cmake.org/). If you are not familiar with cmake, you should read the [cmake documentation](https://cmake.org/documentation/). If you are familiar with cmake, you can proceed to the next step.

The build process starts at the root directory of the repository. Make sure to make a cup of coffee before you start the build process because it will take a while. If you are not sure how to make a cup of coffee, you should read the [coffee documentation](https://en.wikipedia.org/wiki/Coffee). If you disagree with the coffee documentation, you should read the [tea documentation](https://en.wikipedia.org/wiki/Tea). If you disagree with both the coffee and the tea documentation, I am sorry, but I cannot help you. Water is also a choice, but I do not recommend it. Supposing that you have made a cup of coffee (or tea), you can proceed to the next step.

First, sit down and relax. You have made a cup of coffee (or tea), so you deserve a break. If you are not sure how to sit down and relax, you should read the [relaxation documentation](https://en.wikipedia.org/wiki/Relaxation). Okay, now you can proceed to the next step.

Make the build directory and change to it:

```bash
mkdir build
cd build
```

Now, you can run cmake to generate the build files:

```bash
cmake ..
```

Now, that you have generated the build files, you can build the software:

```bash
cmake --build .
```

While waiting for the build process to finish, you can read the [user interface documentation](ui.md).

Congratulations, you have successfully built the software. Now, you can proceed to the next step.

Run the software:

```bash
./main
```
